'PA-08M2 Rain Data Receiver LCD117 16x2 Display
'PICAXE Tutorial
'Project: Tipping Bucket Rain Gauge
'9 Aug 2016
'Schematic: PA-08M2 Rain Data Receiver.dch
'Code: PA-08M2 Rain Data Receiver LCD117 16x2 Display.bas
'Overview: Receive pulses from a tipping bucket rain catcher,
	     'convert pulse count to rainfall measurement, and
		  'display results on LCD.
#picaxe 08M2 'Identify the PICAXE being used as an 08M2.
#no_data 'Prevent data from being downloaded to PICAXE.
symbol tip_in = C.3
symbol rst_count = C.2
symbol tips_total = w2
symbol whole_dig = b6
symbol tenths_dig = b7
symbol hunths_dig = b8
symbol baud = T2400
symbol LCD = C.4
high C.4 'Set pinC.4 high while LCD117 boots.
	pause 5000 'Pause 5 seconds for LCD to boot.
tips_total = 0
serout LCD, baud, ("?f")
main:
do 'Begin do loop.
	serout LCD, baud, ("?a?y0?x00Tips = ",#tips_total)
		'Position cursor at row 0, column 00 and send Tips = tips_total.
	serout LCD, baud, ("?a?y1?x00Rain = ",#whole_dig, ".", #tenths_dig, #hunths_dig, " in.")
		'Position cursor at row 1, column 00 and send Rain = whole.tenthshunths in.
	button tip_in, 1, 255, 255, b2, 1, IncrementTips 'Check input connected to pin C.3;
		'If input is high, go to IncrementTips.
	button rst_count, 1, 255, 255, b3, 1, ZeroTips 'Check button connected to pin C.2;
		'If button is pressed, go to ZeroTips.
	select tips_total 'Based on tips_total, load appropriate whole, tenths, and hunths values.
		case 0
			whole_dig = 0
			tenths_dig = 0
			hunths_dig = 0
		case 1
			whole_dig = 0
			tenths_dig = 0
			hunths_dig = 3
		case 2
			whole_dig = 0
			tenths_dig = 0
			hunths_dig = 6
		case 3
			whole_dig = 0
			tenths_dig = 1
			hunths_dig = 0
		case 4
			whole_dig = 0
			tenths_dig = 1
			hunths_dig = 3
		case 5
			whole_dig = 0
			tenths_dig = 1
			hunths_dig = 6
		case 6
			whole_dig = 0
			tenths_dig = 1
			hunths_dig = 9
		case 7
			whole_dig = 0
			tenths_dig = 2
			hunths_dig = 2
		case 8
			whole_dig = 0
			tenths_dig = 2
			hunths_dig = 5
		case 9
			whole_dig = 0
			tenths_dig = 2
			hunths_dig = 9
		case 10
			whole_dig = 0
			tenths_dig = 3
			hunths_dig = 2
		case 11
			whole_dig = 0
			tenths_dig = 3
			hunths_dig = 5
		case 12
			whole_dig = 0
			tenths_dig = 3
			hunths_dig = 8
		case 13
			whole_dig = 0
			tenths_dig = 4
			hunths_dig = 1
		case 14
			whole_dig = 0
			tenths_dig = 4
			hunths_dig = 4
		case 15
			whole_dig = 0
			tenths_dig = 4
			hunths_dig = 8
		case 16
			whole_dig = 0
			tenths_dig = 5
			hunths_dig = 1
		case 17
			whole_dig = 0
			tenths_dig = 5
			hunths_dig = 4
		case 18
			whole_dig = 0
			tenths_dig = 5
			hunths_dig = 7
		case 19
			whole_dig = 0
			tenths_dig = 6
			hunths_dig = 0
		case 20
			whole_dig = 0
			tenths_dig = 6
			hunths_dig = 3
		case 21
			whole_dig = 0
			tenths_dig = 6
			hunths_dig = 7
		case 22
			whole_dig = 0
			tenths_dig = 7
			hunths_dig = 0
		case 23
			whole_dig = 0
			tenths_dig = 7
			hunths_dig = 3
		case 24
			whole_dig = 0
			tenths_dig = 7
			hunths_dig = 6
		case 25
			whole_dig = 0
			tenths_dig = 7
			hunths_dig = 9
		case 26
			whole_dig = 0
			tenths_dig = 8
			hunths_dig = 2
		case 27
			whole_dig = 0
			tenths_dig = 8
			hunths_dig = 6
		case 28
			whole_dig = 0
			tenths_dig = 8
			hunths_dig = 9
		case 29
			whole_dig = 0
			tenths_dig = 9
			hunths_dig = 2
		case 30
			whole_dig = 0
			tenths_dig = 9
			hunths_dig = 5
		case 31
			whole_dig = 0
			tenths_dig = 9
			hunths_dig = 8
		case 32
			whole_dig = 1
			tenths_dig = 0
			hunths_dig = 1
		case 33
			whole_dig = 1
			tenths_dig = 0
			hunths_dig = 5
		case 34
			whole_dig = 1
			tenths_dig = 0
			hunths_dig = 8
		case 35
			whole_dig = 1
			tenths_dig = 1
			hunths_dig = 1
		case 36
			whole_dig = 1
			tenths_dig = 1
			hunths_dig = 4
		case 37
			whole_dig = 1
			tenths_dig = 1
			hunths_dig = 7
		case 38
			whole_dig = 1
			tenths_dig = 2
			hunths_dig = 1
		case 39
			whole_dig = 1
			tenths_dig = 2
			hunths_dig = 4
		case 40
			whole_dig = 1
			tenths_dig = 2
			hunths_dig = 7
		case 41
			whole_dig = 1
			tenths_dig = 3
			hunths_dig = 0
		case 42
			whole_dig = 1
			tenths_dig = 3
			hunths_dig = 3
		case 43
			whole_dig = 1
			tenths_dig = 3
			hunths_dig = 6
		case 44
			whole_dig = 1
			tenths_dig = 4
			hunths_dig = 0
		case 45
			whole_dig = 1
			tenths_dig = 4
			hunths_dig = 3
		case 46
			whole_dig = 1
			tenths_dig = 4
			hunths_dig = 6
		case 47
			whole_dig = 1
			tenths_dig = 4
			hunths_dig = 9
		case 48
			whole_dig = 1
			tenths_dig = 5
			hunths_dig = 2
		case 49
			whole_dig = 1
			tenths_dig = 5
			hunths_dig = 5
		case 50
			whole_dig = 1
			tenths_dig = 5
			hunths_dig = 9
		case 51
			whole_dig = 1
			tenths_dig = 6
			hunths_dig = 2
		case 52
			whole_dig = 1
			tenths_dig = 6
			hunths_dig = 5
		case 53
			whole_dig = 1
			tenths_dig = 6
			hunths_dig = 8
		case 54
			whole_dig = 1
			tenths_dig = 7
			hunths_dig = 1
		case 55
			whole_dig = 1
			tenths_dig = 7
			hunths_dig = 4
		case 56
			whole_dig = 1
			tenths_dig = 7
			hunths_dig = 8
		case 57
			whole_dig = 1
			tenths_dig = 8
			hunths_dig = 1
		case 58
			whole_dig = 1
			tenths_dig = 8
			hunths_dig = 4
		case 59
			whole_dig = 1
			tenths_dig = 8
			hunths_dig = 7
		case 60
			whole_dig = 1
			tenths_dig = 9
			hunths_dig = 0
		case 61
			whole_dig = 1
			tenths_dig = 9
			hunths_dig = 3
		case 62
			whole_dig = 1
			tenths_dig = 9
			hunths_dig = 7
		case 63
			whole_dig = 2
			tenths_dig = 0
			hunths_dig = 0
		case 64
			whole_dig = 2
			tenths_dig = 0
			hunths_dig = 3
		case 65
			whole_dig = 2
			tenths_dig = 0
			hunths_dig = 6
		case 66
			whole_dig = 2
			tenths_dig = 0
			hunths_dig = 9
		case 67
			whole_dig = 2
			tenths_dig = 1
			hunths_dig = 2
		case 68
			whole_dig = 2
			tenths_dig = 1
			hunths_dig = 6
		case 69
			whole_dig = 2
			tenths_dig = 1
			hunths_dig = 9
		case 70
			whole_dig = 2
			tenths_dig = 2
			hunths_dig = 2
		case 71
			whole_dig = 2
			tenths_dig = 2
			hunths_dig = 5
		case 72
			whole_dig = 2
			tenths_dig = 2
			hunths_dig = 8
		case 73
			whole_dig = 2
			tenths_dig = 3
			hunths_dig = 2
		case 74
			whole_dig = 2
			tenths_dig = 3
			hunths_dig = 5
		case 75
			whole_dig = 2
			tenths_dig = 3
			hunths_dig = 8
		case 76
			whole_dig = 2
			tenths_dig = 4
			hunths_dig = 1
		case 77
			whole_dig = 2
			tenths_dig = 4
			hunths_dig = 4
		case 78
			whole_dig = 2
			tenths_dig = 4
			hunths_dig = 7
		case 79
			whole_dig = 2
			tenths_dig = 5
			hunths_dig = 1
		case 80
			whole_dig = 2
			tenths_dig = 5
			hunths_dig = 4
		case 81
			whole_dig = 2
			tenths_dig = 5
			hunths_dig = 7
		case 82
			whole_dig = 2
			tenths_dig = 6
			hunths_dig = 0
		case 83
			whole_dig = 2
			tenths_dig = 6
			hunths_dig = 3
		case 84
			whole_dig = 2
			tenths_dig = 6
			hunths_dig = 6
		case 85
			whole_dig = 2
			tenths_dig = 7
			hunths_dig = 0
		case 86
			whole_dig = 2
			tenths_dig = 7
			hunths_dig = 3
		case 87
			whole_dig = 2
			tenths_dig = 7
			hunths_dig = 6
		case 88
			whole_dig = 2
			tenths_dig = 7
			hunths_dig = 9
		case 89
			whole_dig = 2
			tenths_dig = 8
			hunths_dig = 2
		case 90
			whole_dig = 2
			tenths_dig = 8
			hunths_dig = 5
		case 91
			whole_dig = 2
			tenths_dig = 8
			hunths_dig = 9
		case 92
			whole_dig = 2
			tenths_dig = 9
			hunths_dig = 2
		case 93
			whole_dig = 2
			tenths_dig = 9
			hunths_dig = 5
		case 94
			whole_dig = 2
			tenths_dig = 9
			hunths_dig = 8	
		case 95
			whole_dig = 3
			tenths_dig = 0
			hunths_dig = 1
		case >95
			goto ZeroTips
	endselect
loop 'Loop.
IncrementTips:
	tips_total = tips_total + 1
	'Increment tips_total by 1.
	serout LCD, baud, ("?f")
	'Clear the LCD and home the cursor.
	serout LCD, T2400, ("Tips = ",#tips_total)
	'Send Tips = tips_total.
	goto main 'Go to main and do it all again.
ZeroTips:
	tips_total = 0
	serout LCD, baud, ("?f")
	'Clear the LCD and home the cursor.
	serout LCD, baud, ("Tips = ",#tips_total)
	'Send Tips = tips_total.
	goto main 'Go to main and do it all again.